SRC="src/main.cpp src/compiler.cpp src/cache.cpp src/tmake.cpp src/project.cpp src/package.cpp src/functions/output.cpp src/functions/input.cpp src/functions/lua.cpp src/functions/filesystem.cpp src/functions/strings.cpp src/commands/tmake.cpp src/commands/project.cpp src/commands/find.cpp src/commands/compiler.cpp src/commands/os.cpp src/commands/strings.cpp src/commands/filesystem.cpp"
ARCH=`uname -m`
OS=`uname -o`

if [ "$OS" = "GNU/Linux" ]; then
    LUAPKG="lua"

    pkg-config --exists lua         # Arch Linux
    if [ $? == 1 ]; then
        pkg-config --exists lua5.1  # Ubuntu, and others
        if [ $? == 0 ]; then
            LUAPKG="lua5.1"
        fi
    fi

    if [ "$ARCH" = "x86_64" ]; then
        g++ -m64 -rdynamic $SRC src/arch/x86_64.cpp src/os/linux.cpp -o tmake -Iinclude -DARCH=x86_64 -DLINUX -static `pkg-config --libs --cflags $LUAPKG` -std=c++0x -Wall -ldl
    else
        g++ -m32 -rdynamic $SRC src/arch/x86_32.cpp src/os/linux.cpp -o tmake -Iinclude -DARCH=x86_32 -DLINUX -static `pkg-config --libs --cflags $LUAPKG` -std=c++0x -Wall -ldl
    fi
elif [ "$OS" = "Haiku" ]; then
    setgcc gcc4

    if [ "$ARCH" = "x86_64" ]; then
        g++ -m64 $SRC src/arch/x86_64.cpp src/os/haiku.cpp -o tmake -Iinclude -DARCH=x86_64 -DHAIKU /boot/common/lib/gcc4/liblua.a -std=c++0x -Wall
    else
        g++ -m32 $SRC src/arch/x86_32.cpp src/os/haiku.cpp -o tmake -Iinclude -DARCH=x86_32 -DHAIKU /boot/common/lib/gcc4/liblua.a -std=c++0x -Wall
    fi
elif [ "$OS" = "FreeBSD" ]; then
    if [ "$ARCH" = "x86_64" ]; then
        g++ -m64 $SRC src/arch/x86_64.cpp src/os/freebsd.cpp -o tmake -Iinclude -DARCH=x86_64 -DFREEBSD -llua -std=c++0x -Wall
    else
        g++ -m32 $SRC src/arch/x86_32.cpp src/os/freebsd.cpp -o tmake -Iinclude -DARCH=x86_32 -DFREEBSD -llua -std=c++0x -Wall
    fi
elif [ "$OS" = "NetBSD" ]; then
    if [ "$ARCH" = "x86_64" ]; then
        g++ -m64 $SRC src/arch/x86_64.cpp src/os/netbsd.cpp -o tmake -Iinclude -DARCH=x86_64 -DNETBSD -llua -std=c++0x -Wall
    else
        g++ -m32 $SRC src/arch/x86_32.cpp src/os/netbsd.cpp -o tmake -Iinclude -DARCH=x86_32 -DNETBSD -llua -std=c++0x -Wall
    fi
else
    echo Your operating system is not supported at the moment.
fi
