local monocExe = PickExecutable("dmcs")

if monocExe ~= "" and FindExecutable(monocExe) then
    function monoc_LibraryExists(lib)
        return true
    end

    function monoc_Deps(file)
        return {}
    end

    function monoc_Compile(src, type)
        return true
    end

    -- We need this so that on all platforms the correct extensions are choosen
    function monoc_FileName(file, type)
        if type == "exe" then
            return file .. ".exe"
        end

        return file .. ".dll"
    end

    function monoc_Link(executable, type, options)
        local cmd = monocExe .. " -out:\"" .. BuildDir .. executable .. "\""

        cmd = cmd .. StrJoin(GetSources(), " \"" .. SrcDir(), "\"")
        cmd = cmd .. StrJoin(GetDefinitions(), " \"-define:", "\"")
        cmd = cmd .. StrJoin(GetCFlags(), " \"", "\"")
        cmd = cmd .. StrJoin(GetLFlags(), " \"", "\"")

        if TableHas(options, "unsafe") then
            cmd = cmd .. " -unsafe"
        end

        if Execute(cmd, false) == 0 then
            return true
        end

        return false
    end

    RegisterCompiler("monoc", "C#")
end
