local lib = PickLibrary("QtCore")
local incDir = PickIncludeDir("/usr/include/QtCore/", "/usr/include/qt4/QtCore/")

if lib ~= "" and FindLibrary(lib) and FindExecutable("moc") and FindExecutable("rcc") and FindExecutable("uic") then
    function QtCore_Package()
        local libs = { lib }
        local incDirs = { incDir, PickIncludeDir("/usr/include/qt4/", "/usr/include/") }
        local libDirs = { }
        local defs = { "QTCORE_SUPPORT" }
        local cflags = { }
        local lflags = { }

        return -1, libs, incDirs, libDirs, defs, cflags, lflags
    end

    function QtMoc(header)
        if RequiresCompiling(HeaderDir() .. header, SrcDir() .. header .. ".moc.cpp") then
            Print("Generating Qt Moc: " .. header)
            if Execute("moc " .. HeaderDir() .. header .. " -o" .. SrcDir() .. header .. ".moc.cpp", false) ~= 0 then
                error("Failed to generate moc")
            end
        end

        return header .. ".moc.cpp"
    end

    function QtRes(res)
        if RequiresCompiling(ResDir() .. res, SrcDir() .. res .. ".cpp") then
            Print("Generating Qt Resource: " .. res)
            if Execute("rcc " .. ResDir() .. res .. " -o" .. SrcDir() .. res .. ".cpp", false) ~= 0 then
                error("Failed to generate resource file")
            end
       end

        return res .. ".cpp"
    end

    function QtUi(ui)
        if RequiresCompiling(ResDir() .. ui, HeaderDir() .. ui .. ".hpp") then
            Print("Generating Qt User Interface: " .. ui)
            if Execute("uic " .. ResDir() .. ui .. " -o " .. HeaderDir() .. ui .. ".hpp", false) ~= 0 then
                error("Failed to generate user interface file")
            end
        end

        return ui .. ".hpp"
    end
end
