#ifndef CACHE_HPP
#define CACHE_HPP

class Cache
{
    public:
        Cache();
        ~Cache();

        void sync();
        void write();
        void read();

        void addLib(string name);
        void addIncDir(string name);
        void addLibDir(string name);
        void addOption(string name, bool value);

        bool optionExists(string name);

        bool checkLib(string name);
        bool checkIncDir(string name);
        bool checkLibDir(string name);
        bool checkOption(string name);

        void setPickString(const vector<string> &choices, string choice);
        string pickString(const vector<string> &choices);

        string convertIntoPickName(vector<string> choices);

        void setGeneratedFiles(vector<string> files);
        vector<string> getGeneratedFiles();

        void setInstallFiles(map<string, string> files);
        map<string, string> getInstallFiles();

    private:
        map<string, string> libs;
        map<string, string> incDirs;
        map<string, string> libDirs;
        vector<string> genFiles;
        map<string, string> instFiles;
        map<string, string> options;
        map<string, string> picks;
};

#endif // CACHE_HPP
