#ifndef COMMANDS_HPP
#define COMMANDS_HPP

int Func_RequireVersion(lua_State *L);

int Func_Project(lua_State *L);

int Func_SetCompiler(lua_State *L);

int Func_SrcDir(lua_State *L);
int Func_HeaderDir(lua_State *L);
int Func_ResDir(lua_State *L);

int Func_BinDir(lua_State *L);
int Func_LibDir(lua_State *L);
int Func_IncDir(lua_State *L);
int Func_ConfDir(lua_State *L);
int Func_DataDir(lua_State *L);

int Func_CompiledName(lua_State *L);

int Func_GetSources(lua_State *L);
int Func_GetHeaders(lua_State *L);
int Func_GetResources(lua_State *L);
int Func_GetLibraries(lua_State *L);
int Func_GetIncludeDirs(lua_State *L);
int Func_GetLibraryDirs(lua_State *L);
int Func_GetDefinitions(lua_State *L);
int Func_GetCFlags(lua_State *L);
int Func_GetLFlags(lua_State *L);
int Func_GetOption(lua_State *L);

int Func_AddSource(lua_State *L);
int Func_AddHeader(lua_State *L);
int Func_AddResource(lua_State *L);
int Func_AddPackage(lua_State *L);
int Func_AddLibrary(lua_State *L);
int Func_AddIncludeDir(lua_State *L);
int Func_AddLibraryDir(lua_State *L);
int Func_AddDefinition(lua_State *L);
int Func_AddCFlag(lua_State *L);
int Func_AddLFlag(lua_State *L);
int Func_AddOption(lua_State *L);

int Func_CreateExecutable(lua_State *L);
int Func_CreateSharedLibrary(lua_State *L);
int Func_CreateStaticLibrary(lua_State *L);

int Func_FindExecutable(lua_State *L);
int Func_FindPackage(lua_State *L);
int Func_FindLibrary(lua_State *L);
int Func_FindIncludeDir(lua_State *L);
int Func_FindLibraryDir(lua_State *L);

int Func_PickExecutable(lua_State *L);
int Func_PickLibrary(lua_State *L);
int Func_PickIncludeDir(lua_State *L);
int Func_PickLibraryDir(lua_State *L);

int Func_Execute(lua_State *L);
int Func_Install(lua_State *L);

int Func_Print(lua_State *L);
int Func_Warning(lua_State *L);

int Func_RegisterCompiler(lua_State *L);
int Func_AlterCompiler(lua_State *L);
int Func_RequiresCompiling(lua_State *L);

int Func_FS_Mkdir(lua_State *L);
int Func_FS_Rm(lua_State *L);
int Func_FS_Move(lua_State *L);
int Func_FS_Copy(lua_State *L);
int Func_FS_WriteFile(lua_State *L);

int Func_StrJoin(lua_State *L);
int Func_StrSplit(lua_State *L);
int Func_StrEmpty(lua_State *L);

int Func_TableHas(lua_State *L);

#endif // COMMANDS_HPP
