#ifndef COMPILER_HPP
#define COMPILER_HPP

class Compiler
{
    public:
        Compiler(lua_State *L, string n, string l);
        ~Compiler();

        void reset();

        string getName();
        string getLanguage();

        void alter(string type, string functionName);

        bool libraryExists(string lib);
        vector<string> dependencies(string filename);
        bool compile(string source, string type, vector<string> options);
        bool link(string executable, string type, vector<string> options);

        string getComputerName(string file, string type);

    private:
        lua_State *luaState;

        string name;
        string language;

        string libExistsName;
        string depsName;
        string compileName;
        string linkName;
};

#endif // COMPILER_HPP
