#ifndef OS_HPP
#define OS_HPP

#include <cstdlib>

namespace OS
{
    void init();
    void end();
    
    string name();

    string convertPath(string oldPath);
    char pathSep();

    string getName(string type, string exe);

    string compilersDir();
    string packagesDir();
    string templatesDir();

    vector<string> paths();

    bool mkdir(string dir);
    bool rm(string filename);
    bool mv(string source, string location);
    bool cp(string source, string location);

    string binDir(string n);
    string libDir(string n);
    string incDir(string n);
    string confDir(string n);
    string dataDir(string n);
    
    string colourNone();
    string colourRed();
    string colourGreen();
    string colourBlue();
    string colourYellow();
}

#endif // OS_HPP
