#ifndef TMAKE_HPP
#define TMAKE_HPP

#define VERSION     1.1
#define STR_VERSION "1.1"

namespace GlobalActions
{
    enum GlobalAction
    {
        Project,
        Create
    };
}

class TMake
{
    public:
        TMake();
        ~TMake();
        
        void printHelp();
        bool parseArg(string arg);
        
        bool init();
        bool initLua();
        void initLuaFunctions();
        void initLuaVariables();

        void initCompilers();

        int run();
        
        void end();

        void registerCompiler(string name, string language);
        Compiler *chooseCompiler(string language);
        Compiler *getCompiler(string name, string language);

        void createBuildDir(string sourcefile);
        string convertName(string name);
        
        bool debugMode();
        string getAction();
        Project *getProject();
        Package *getPackage(string name);

        string srcDir;
        string headerDir;
        string resDir;

        Cache *cache;

        string binDir;
        string libDir;
        string incDir;
        string confDir;
        string dataDir;
        
    private:
        lua_State *luaState;
        
        string action;
        Project *project;

        map<string, Package *> packages;
        vector<Compiler *> compilers;

        GlobalActions::GlobalAction globalAction;
        
        bool isDebugMode;
};

extern TMake *tmake;

#endif // TMAKE_HPP
