#include "headers.hpp"

int Func_RegisterCompiler(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        string name = Lua::getString(L, 1);
        string language = Lua::getString(L, 2);

        tmake->registerCompiler(name, language);
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_AlterCompiler(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        string type = Lua::getString(L, 1);
        string functionName = Lua::getString(L, 2);

        tmake->getProject()->getCompiler()->alter(type, functionName);
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_RequiresCompiling(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        Lua::pushBool(L, FS::requiresCompiling(Lua::getString(L, 1), Lua::getString(L, 2)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}
