#include "headers.hpp"

int Func_FindExecutable(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushBool(L, tmake->getProject()->executableExists(Lua::getString(L, 1), false));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_FindPackage(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        string pkg = Lua::getString(L, 1);
        Lua::pushBool(L, tmake->getProject()->packageExists(pkg, false));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_FindLibrary(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        string lib = Lua::getString(L, 1);
        Lua::pushBool(L, tmake->getProject()->libraryExists(lib, false));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_FindIncludeDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        string dir = Lua::getString(L, 1);
        Lua::pushBool(L, tmake->getProject()->includeDirExists(dir, false));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_FindLibraryDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        string dir = Lua::getString(L, 1);
        Lua::pushBool(L, tmake->getProject()->libraryDirExists(dir, false));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_PickExecutable(lua_State *L)
{
    vector<string> choices;

    int s = lua_gettop(L);
    for (int i = 1; i <= s; i++)
    {
        string s = Lua::getString(L, i);
        choices.push_back(s);
    }

    string pick = tmake->cache->pickString(choices);
    if (pick.empty())
    {
        for (int i = 0; i < s; i++)
        {
            string executable = choices[i];
            if (tmake->getProject()->executableExists(executable, false))
            {
                tmake->cache->setPickString(choices, executable);
                Lua::pushString(L, executable);
                return 1;
            }
        }
    }
    else
    {
        Lua::pushString(L, pick);
        return 1;
    }

    Lua::pushString(L, "");
    return 1;
}

int Func_PickLibrary(lua_State *L)
{
    vector<string> choices;

    int s = lua_gettop(L);
    for (int i = 1; i <= s; i++)
    {
        choices.push_back(Lua::getString(L, i));
    }

    string pick = tmake->cache->pickString(choices);
    if (pick.empty())
    {
        for (int i = 0; i < s; i++)
        {
            string executable = choices[i];
            if (tmake->getProject()->libraryExists(executable, false))
            {
                tmake->cache->setPickString(choices, executable);
                Lua::pushString(L, executable);
                return 1;
            }
        }
    }
    else
    {
        Lua::pushString(L, pick);
        return 1;
    }

    Lua::pushString(L, "");
    return 1;
}

int Func_PickIncludeDir(lua_State *L)
{
    vector<string> choices;

    int s = lua_gettop(L);
    for (int i = 1; i <= s; i++)
    {
        choices.push_back(Lua::getString(L, i));
    }

    string pick = tmake->cache->pickString(choices);
    if (pick.empty())
    {
        for (int i = 0; i < s; i++)
        {
            string executable = choices[i];
            if (tmake->getProject()->includeDirExists(executable, false))
            {
                tmake->cache->setPickString(choices, executable);
                Lua::pushString(L, executable);
                return 1;
            }
        }
    }
    else
    {
        Lua::pushString(L, pick);
        return 1;
    }

    Lua::pushString(L, "");
    return 1;
}

int Func_PickLibraryDir(lua_State *L)
{
    vector<string> choices;

    int s = lua_gettop(L);
    for (int i = 1; i <= s; i++)
    {
        choices.push_back(Lua::getString(L, i));
    }

    string pick = tmake->cache->pickString(choices);
    if (pick.empty())
    {
        for (int i = 0; i < s; i++)
        {
            string executable = choices[i];
            if (tmake->getProject()->libraryDirExists(executable, false))
            {
                tmake->cache->setPickString(choices, executable);
                Lua::pushString(L, executable);
                return 1;
            }
        }
    }
    else
    {
        Lua::pushString(L, pick);
        return 1;
    }

    Lua::pushString(L, "");
    return 1;
}
