#include "headers.hpp"

int Func_Execute(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1 || s == 2)
    {
        string command = Lua::getString(L, 1);
        bool print = true;

        if (s == 2)
        {
            print = Lua::getBool(L, 2);
        }

        tuple<int, string> ret = execute(command, print);

        Lua::pushInteger(L, get<0>(ret));
        Lua::pushString(L, get<1>(ret));
    }
    else
    {
        Lua::error(L);
    }

    return 2;
}

int Func_Install(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        tmake->getProject()->installFiles[Lua::getString(L, 1)] = Lua::getString(L, 2);
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_Print(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Output::print(Lua::getString(L, 1));
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_Warning(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Output::warning(Lua::getString(L, 1));
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}
