#include "headers.hpp"

int Func_Project(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        tmake->getProject()->reset();

        tmake->getProject()->setName(Lua::getString(L, 1));
        tmake->getProject()->setLanguage(Lua::getString(L, 2));
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_SetCompiler(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        tmake->getProject()->setCompiler(Lua::getString(L, 1));
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_SrcDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushString(L, tmake->srcDir);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_HeaderDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushString(L, tmake->headerDir);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_ResDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushString(L, tmake->resDir);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_BinDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushString(L, tmake->getProject()->binDir(Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_LibDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushString(L, tmake->getProject()->libDir(Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_IncDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushString(L, tmake->getProject()->incDir(Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_ConfDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushString(L, tmake->getProject()->confDir(Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_DataDir(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushString(L, tmake->getProject()->dataDir(Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_CompiledName(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        Lua::pushString(L, tmake->getProject()->getCompiledName(Lua::getString(L, 2), Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetSources(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->sources);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetHeaders(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->headers);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetResources(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->resources);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetLibraries(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->libraries);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetIncludeDirs(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->includeDirs);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetLibraryDirs(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->libraryDirs);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetDefinitions(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->definitions);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetCFlags(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->cflags);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetLFlags(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 0)
    {
        Lua::pushStringList(L, tmake->getProject()->lflags);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_GetOption(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushBool(L, tmake->getProject()->getOption(Lua::getString(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_AddSource(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);

        bool generated = false;
        if (lua_isboolean(L, s))
        {
            generated = Lua::getBool(L, s);
            s = s - 1;
        }

        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addSource(OS::convertPath(Lua::getString(L, i)), generated);
        }
    }

    return 0;
}

int Func_AddHeader(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);

        bool generated = false;
        if (lua_isboolean(L, s))
        {
            generated = Lua::getBool(L, s);
            s = s - 1;
        }

        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addHeader(OS::convertPath(Lua::getString(L, i)), generated);
        }
    }

    return 0;
}

int Func_AddResource(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);

        bool generated = false;
        if (lua_isboolean(L, s))
        {
            generated = Lua::getBool(L, s);
            s = s - 1;
        }

        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addResource(OS::convertPath(Lua::getString(L, i)), generated);
        }
    }

    return 0;
}

int Func_AddPackage(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        if (s >= 1 && s <= 3)
        {
            string name = Lua::getString(L, 1);
            float minVersion = -1;
            float maxVersion = -1;

            if (s > 1)
            {
                minVersion = Lua::getFloat(L, 2);
                if (s > 2)
                {
                    maxVersion = Lua::getFloat(L, 3);
                }
             }

            tmake->getProject()->addPackage(name, minVersion, maxVersion);
        }
        else
        {
            Lua::error(L);
        }
    }

    return 0;
}

int Func_AddLibrary(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addLibrary(Lua::getString(L, i));
        }
    }

    return 0;
}

int Func_AddIncludeDir(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addIncludeDir(Lua::getString(L, i));
        }
    }

    return 0;
}

int Func_AddLibraryDir(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addLibraryDir(Lua::getString(L, i));
        }
    }

    return 0;
}

int Func_AddDefinition(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addDefinition(Lua::getString(L, i));
        }
    }

    return 0;
}

int Func_AddCFlag(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        for (int i = 1; i <= s; i++)
        {
            tmake->getProject()->addCFlag(Lua::getString(L, i));
        }
    }

    return 0;
}

int Func_AddLFlag(lua_State *L)
{
    int s = lua_gettop(L);
    for (int i = 1; i <= s; i++)
    {
        tmake->getProject()->addLFlag(Lua::getString(L, i));
    }

    return 0;
}

int Func_AddOption(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2 || s == 3)
    {
        string name = Lua::getString(L, 1);
        string description = Lua::getString(L, 2);
        bool d = true;
        if (s == 3)
        {
            d = Lua::getBool(L, 3);
        }

        tmake->getProject()->addOption(name, description, d);
    }
    else
    {
        Lua::error(L);
    }

    return 0;
}

int Func_CreateExecutable(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        if (s == 1 || s == 2)
        {
            string name = Lua::getString(L, 1);
            name = tmake->getProject()->getCompiledName("exe", name);

            vector<string> options;
            if (s == 2)
            {
                options = Lua::getStringList(L, 2);
            }

            bool somethingWasCompiled = false;

            for (unsigned int i = 0; i < tmake->getProject()->sources.size(); i++)
            {
                string source = tmake->getProject()->sources[i];
                if (FS::requiresCompiling(tmake->srcDir + source, Arch::buildDir() + source + ".o"))
                {
                    tmake->createBuildDir(Arch::buildDir() + source);
                    Output::print("Compiling: " + source);

                    if (tmake->getProject()->getCompiler()->compile(source, "exe", options))
                    {
                        somethingWasCompiled = true;
                    }
                    else
                    {
                        Lua::error(L, "Failed to compile");
                    }
                }
            }

            if (somethingWasCompiled)
            {
                Output::print("Linking: " + name);
                if (!tmake->getProject()->getCompiler()->link(name, "exe", options))
                {
                    Lua::error(L, "Failed to link");
                }
            }
        }
        else
        {
            Lua::error(L);
        }
    }

    return 0;
}

int Func_CreateSharedLibrary(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        if (s == 1 || s == 2)
        {
            string name = Lua::getString(L, 1);
            name = tmake->getProject()->getCompiledName("shared", name);

            vector<string> options;
            if (s == 2)
            {
                options = Lua::getStringList(L, 2);
            }

            bool somethingWasCompiled = false;

            for (unsigned int i = 0; i < tmake->getProject()->sources.size(); i++)
            {
                string source = tmake->getProject()->sources[i];
                if (FS::requiresCompiling(tmake->srcDir + source, Arch::buildDir() + source + ".o"))
                {
                    tmake->createBuildDir(Arch::buildDir() + source);
                    Output::print("Compiling: " + source);

                    if (tmake->getProject()->getCompiler()->compile(source, "shared", options))
                    {
                        somethingWasCompiled = true;
                    }
                    else
                    {
                        Lua::error(L, "Failed to compile");
                    }
                }
            }

            if (somethingWasCompiled)
            {
                Output::print("Linking: " + name);
                if (!tmake->getProject()->getCompiler()->link(name, "shared", options))
                {
                    Lua::error(L, "Failed to link");
                }
            }
        }
        else
        {
            Lua::error(L);
        }
    }

    return 0;
}

int Func_CreateStaticLibrary(lua_State *L)
{
    if (tmake->getAction() == "build")
    {
        int s = lua_gettop(L);
        if (s == 1 || s == 2)
        {
            string name = Lua::getString(L, 1);
            name = tmake->getProject()->getCompiledName("static", name);

            vector<string> options;
            if (s == 2)
            {
                options = Lua::getStringList(L, 2);
            }

            bool somethingWasCompiled = false;

            for (unsigned int i = 0; i < tmake->getProject()->sources.size(); i++)
            {
                string source = tmake->getProject()->sources[i];
                if (FS::requiresCompiling(tmake->srcDir + source, Arch::buildDir() + source + ".o"))
                {
                    tmake->createBuildDir(Arch::buildDir() + source);
                    Output::print("Compiling: " + source);

                    if (tmake->getProject()->getCompiler()->compile(source, "static", options))
                    {
                        somethingWasCompiled = true;
                    }
                    else
                    {
                        Lua::error(L, "Failed to compile");
                    }
                }
            }

            if (somethingWasCompiled)
            {
                Output::print("Linking: " + name);
                if (!tmake->getProject()->getCompiler()->link(name, "static", options))
                {
                    Lua::error(L, "Failed to link");
                }
            }
        }
        else
        {
            Lua::error(L);
        }
    }

    return 0;
}
