#include "headers.hpp"

int Func_StrJoin(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1 || s == 2 || s == 3)
    {
        vector<string> items = Lua::getStringList(L, 1);
        string startDelim;
        string endDelim;

        if (s >= 2)
        {
            startDelim = Lua::getString(L, 2);
            if (s >= 3)
            {
                endDelim = Lua::getString(L, 3);
            }
        }

        Lua::pushString(L, Str::join(items, startDelim, endDelim));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_StrSplit(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        Lua::pushStringList(L, Str::split(Lua::getString(L, 2), Lua::getChar(L, 1)));
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_StrEmpty(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 1)
    {
        Lua::pushBool(L, Lua::getString(L, 1).empty());
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}

int Func_TableHas(lua_State *L)
{
    int s = lua_gettop(L);
    if (s == 2)
    {
        vector<string> items = Lua::getStringList(L, 1);
        string item = Lua::getString(L, 2);

        bool found = false;
        for (unsigned int i = 0; i < items.size(); i++)
        {
            if (items[i] == item)
            {
                found = true;
            }
        }

        Lua::pushBool(L, found);
    }
    else
    {
        Lua::error(L);
    }

    return 1;
}
