#include <cstdlib>
#include <cstdio>

#include "headers.hpp"

void Output::error(string str)
{
    cout << endl;
    cout << OS::colourRed() << " > " << OS::colourNone() << str << endl;
    cout << endl;
}

void Output::status(string str)
{
    cout << endl;
    cout << OS::colourGreen() << " > " << OS::colourNone() << str << endl;
    cout << endl;
}

void Output::debug(string str)
{
    if (tmake->debugMode())
    {
        cout << OS::colourGreen() << "Debug: " << OS::colourNone() << str << endl;
    }
}

void Output::print(string str, bool newLine)
{
    cout << OS::colourBlue() << " > " << OS::colourNone() << str;

    if (newLine)
    {
        cout << endl;
    }
}

void Output::warning(string str)
{
    cout << OS::colourYellow() << " > " << OS::colourNone() << str << endl;
}

tuple<int, string> execute(string cmd, bool print)
{
    if (print || tmake->debugMode())
    {
        Output::print("Executing: " + cmd);
    }

    FILE* pipe = popen(cmd.c_str(), "r");
    if (!pipe)
    {
        return tuple<int, string>(-1, "ERROR");
    }

    char buffer[128];
    string result;

    while (!feof(pipe))
    {
        if (fgets(buffer, 128, pipe) != NULL)
        {
            result += buffer;
        }
    }

    return tuple<int, string>(pclose(pipe), result);
}
