#include "headers.hpp"

void OS::init()
{
}

void OS::end()
{
}

string OS::name()
{
    return "haiku";
}

string OS::convertPath(string oldPath)
{
    string newPath;

    for (unsigned int i = 0; i < oldPath.size(); i++)
    {
        char c = oldPath[i];
        if (c == '\\')
        {
            newPath.push_back('/');
        }
        else
        {
            newPath.push_back(c);
        }
    }

    return newPath;
}

char OS::pathSep()
{
    return '/';
}

string OS::getName(string type, string exe)
{
    if (type == "exe")
    {
        return exe;
    }
    else if (type == "shared")
    {
        return "lib" + exe + ".so";
    }
    else if (type == "static")
    {
        return "lib" + exe + ".a";
    }

    return exe;
}

string OS::compilersDir()
{
    return "/boot/apps/tmake/compilers/";
}

string OS::packagesDir()
{
    return "/boot/apps/tmake/packages/";
}

string OS::templatesDir()
{
    return "/boot/apps/tmake/templates/";
}

vector<string> OS::paths()
{
    string path = getenv("PATH");
    vector<string> paths = Str::split(path, ':');
    return paths;
}

bool OS::mkdir(string dir)
{
    return system(("mkdir -p " + dir).c_str()) == 0;
}

bool OS::rm(string filename)
{
    return system(("rm -rf " + filename).c_str()) == 0;
}

bool OS::mv(string source, string location)
{
    return system(("mv -f " + source + " " + location).c_str()) == 0;
}

bool OS::cp(string source, string location)
{
    return system(("cp -rf " + source + " " + location).c_str()) == 0;
}

string OS::binDir(string n)
{
    return "/boot/common/bin/";
}

string OS::libDir(string n)
{
    return "/boot/common/lib/";
}

string OS::incDir(string n)
{
    return "/boot/common/include/" + tmake->convertName(n);
}

string OS::confDir(string n)
{
    return "/boot/apps/" + tmake->convertName(n) + "/conf/";
}

string OS::dataDir(string n)
{
    return "/boot/apps/" + tmake->convertName(n) + "/data/";
}

string OS::colourNone()
{
    return "\033[0m";
}

string OS::colourRed()
{
    return "\033[91m";
}

string OS::colourGreen()
{
    return "\033[92m";
}

string OS::colourBlue()
{
    return "\033[94m";
}

string OS::colourYellow()
{
    return "\033[93m";
}
