#include "headers.hpp"
#include <windows.h>

string executableLocation = "C:/Program Files/tmake/";

void OS::init()
{
    char buffer[1024];
    GetModuleFileName(NULL, buffer, sizeof(buffer) - 1);
    
    vector<string> list = Str::split(buffer, '\\');
    if (list.size() >= 1)
    {
        executableLocation = list[0];
        for (unsigned int i = 1; i < list.size() - 1; i++)
        {
            executableLocation.append("/");
            executableLocation.append(list[i]);
        }
    }
}

void OS::end()
{
}

string OS::name()
{
    return "windows";
}

string OS::convertPath(string oldPath)
{
    string newPath;

    for (unsigned int i = 0; i < oldPath.size(); i++)
    {
        char c = oldPath[i];
        if (c == '/')
        {
            newPath.push_back('\\');
        }
        else
        {
            newPath.push_back(c);
        }
    }

    return newPath;
}

char OS::pathSep()
{
    return '\\';
}

string OS::getName(string type, string exe)
{
    if (type == "exe")
    {
        return exe + ".exe";
    }
    else if (type == "shared")
    {
        return "lib" + exe + ".dll";
    }
    else if (type == "static")
    {
        return "lib" + exe + ".a";
    }

    return exe;
}

string OS::compilersDir()
{
    return "C:/Program Files/tmake/compilers/";
}

string OS::packagesDir()
{
    return "C:/Program Files/tmake/packages/";
}

string OS::templatesDir()
{
    return "C:/Program Files/tmake/templates/";
}

vector<string> OS::paths()
{
    string path = getenv("PATH");
    vector<string> paths = Str::split(path, ';');
    return paths;
}

bool OS::mkdir(string dir)
{
    return system(("mkdir \"" + dir + "\"").c_str()) == 0;
}

bool OS::rm(string filename)
{
    int ret = system(("del /F /Q \"" + filename + "\"").c_str());
    if (ret != 0)
    {
        ret = system(("rmdir /S /Q \"" + filename + "\"").c_str());
        if (ret != 0)
        {
            ret = system(("deltree \"" + filename + "\"").c_str());
            if (ret != 0)
            {
                return false;
            }
        }
    }

    return true;
}

bool OS::mv(string source, string location)
{
    return system(("move /Y \"" + source + "\" \"" + location + "\"").c_str()) == 0;
}

bool OS::cp(string source, string location)
{
    return system(("copy /Y /H /C \"" + source + "\" \"" + location + "\"").c_str()) == 0;
}

string OS::binDir(string n)
{
    return "C:/Program Files/" + tmake->convertName(n) + "/";
}

string OS::libDir(string n)
{
    return "C:/Program Files/" + tmake->convertName(n) + "/";
}

string OS::incDir(string n)
{
    return "C:/Program Files/" + tmake->convertName(n) + "/";
}

string OS::confDir(string n)
{
    return "C:/Program Files/" + tmake->convertName(n) + "/conf/";
}

string OS::dataDir(string n)
{
    return "C:/Program Files/" + tmake->convertName(Str::lower(n)) + "/data/";
}

string OS::colourNone()
{
    return "";
}

string OS::colourRed()
{
    return "";
}

string OS::colourGreen()
{
    return "";
}

string OS::colourBlue()
{
    return "";
}

string OS::colourYellow()
{
    return "";
}
