RequireVersion(1.1)

Project("TMake", "C++")

AddSource("main.cpp", "tmake.cpp", "cache.cpp", "compiler.cpp", "project.cpp", "package.cpp", "arch/" .. Arch .. ".cpp", "os/" .. OS .. ".cpp", "commands/project.cpp", "commands/tmake.cpp", "commands/find.cpp", "commands/compiler.cpp", "commands/os.cpp", "commands/strings.cpp", "commands/filesystem.cpp", "functions/lua.cpp", "functions/output.cpp", "functions/input.cpp", "functions/filesystem.cpp", "functions/strings.cpp")

AddOption("UsageSurvey", "Usage Survey Support")
if GetOption("UsageSurvey") then
    if FindPackage("curl") then
        AddPackage("curl")
    else
        Warning("Usage survey disabled due to cURL package not available")
    end
end

AddOption("ThreadSupport", "Threading Support")
if GetOption("ThreadSupport") then
    if FindPackage("pthreads") then
        AddPackage("pthreads")
    else
        Warning("Threading support disabled due to pthreads package not available")
    end
end

AddOption("LuaJit", "Lua JIT Support")
if GetOption("LuaJit") then
    if FindPackage("luajit") then
        AddPackage("luajit")
    else
        Warning("Lua JIT support disabled due to luajit package not available")
        AddPackage("lua", 5.1)
    end
else
    AddPackage("lua", 5.1)
end

CreateExecutable("tmake", { "C++0x" })

Install(BuildDir .. CompiledName("tmake", "exe"), BinDir("tmake"))
Install("conf/*", ConfDir("tmake"))
Install("data/*", DataDir("tmake"))
