import os
import sys

import tornado.httpserver
import tornado.ioloop
import tornado.web
import tornado.database

class BaseHandler(tornado.web.RequestHandler):
    def prepare(self):
        self.database = tornado.database.Connection("localhost", "TMakeStats", "root")

class MainHandler(BaseHandler):
    def get(self):
        self.write("<h3>TMake stats will arrive here shortly...</h3>")
        
class SubmitHandler(BaseHandler):
    def inDatabase(self, ip, version, compiler, language):
        rows = self.database.query("SELECT * FROM Stats WHERE UserDate = CURDATE()")
        for row in rows:
            if row["UserIP"] == ip:
                if row["Version"] == version and row["Compiler"] == compiler and row["Language"] == language:
                    return True
            
        return False
    
    def post(self):
        version = float(self.get_argument("version", ""))
        compiler = str(self.get_argument("compiler", ""))
        language = str(self.get_argument("language", ""))
        ip = str(self.request.remote_ip)

        #print("Submitting Results[" + ip + "]: " + str(version))
        
        if version == 0 and len(compiler) == 0 and len(language) == 0:
            pass
        else:
            if not self.inDatabase(ip, version, compiler, language):
                self.database.execute("INSERT INTO Stats VALUES (0, '" + ip + "', CURDATE(), " + str(version) + ", '" + language + "', '" + compiler + "')")

settings = {
    "static_path": os.path.join(os.path.dirname(__file__), "static"),
    "template_path": os.path.join(os.path.dirname(__file__), "templates"),
    "xsrf_cookies": False,
    "debug": True,
}

application = tornado.web.Application([
    (r"/", MainHandler),
    (r"/submit", SubmitHandler),
    ], **settings)

http_server = tornado.httpserver.HTTPServer(application)
http_server.listen(1234)
tornado.ioloop.IOLoop.instance().start()
